uses
  simplexml; //unita pro parsovn XML


const verze = '0.1.0';
{$INCLUDE GeoTrophy.config.pas}


type TOdznak=record   //odznek
  cache    : string;  //GC kd kee
  obrazek  : string;  //adresa URL obrzku
  jmeno    : string;  //nazev cache
  kategorie: string;  //popis odznku
  popis    : string;  //popis - hodnota
  mam      : boolean; //mm ho?
end;

type TZeme=record              // stty
  id       : integer;          //id sttu
  jmeno    : string;           //jmno sttu
  vitez    : string;           //ikonka winner
  odznaky  : array of TOdznak; //Tabulka odznak
  pocet    : integer;          //pocet odznaku
  vlastneno: integer;          //poet odznk ze sttu
end;

var Xml       : TJclSimpleXML;      //XML parser
    ele,                            //zkladn element, stty
    subele    : TJclSimpleXMLElem;  //subelement, informace o odznku
    props     : TJclSimpleXMLProps; //vlastnosti elementu
    n,                              //potadlo stt
    j,                              //potadlo ke
    i         : Integer;            //potadlo element kee
    pocetZemi : integer;            //poet stt
    Zeme      : array of TZeme;     //zem
    tabulka   : TSQLiteTable;       //Databzov tabulka
    SQL       : string;             //SQL dotaz
    _o_       : string;             //vstup

//-------------Zobrazen progressbaru-------------------------------------------
procedure zobraz(cnt: integer; title: string; max: integer);
begin
  GeoBusyKind(title);
  GeoBusyProgress(cnt, max);
end;

//-------------Nastaven zobrazen progressbaru---------------------------------
procedure kind(id: integer);
var max: integer;
begin
  max:= 6;
  case id of
    0: zobraz(1, 'Sahuji XML', max);
    1: zobraz(2, 'Parsuji XML', max);
    2: zobraz(3, 'Nahrvm data', max);
    3: zobraz(4, 'Dotazy do databze', max);
    4: zobraz(5, 'Generuji odznky', max);
    5: zobraz(6, 'Hotovo!', max);
  end;
end;

//------------Progressbar v caption---------------------------------------------
procedure progress(count, max: integer; title: string);
var kk       : integer; //potadlo
    vv       : string;  //vstup
    procenta : integer; //procenta
    ka       : integer; //ukazatel
begin
  procenta:=count*100/max;
  if procenta > 100 then procenta:=100;
  if procenta < 0 then procenta:=0;
  vv:='[';
  ka:=procenta/5;
  for kk:=0 to ka do vv:=vv+'';
  for kk:=ka+1 to 100/5 do vv:=vv+'';
  vv:=vv+'][' + inttostr(procenta)+ '%]';
  vv:=vv + ' ' + title;
  GeoBusyKind(vv);
end;

function PluginCaption: string;
begin
  Result := 'GeoTroophy';
end;

function PluginHint: string;
begin
  Result := 'Generuje seznam odznak z geotroophy.net';
end;

function PluginIcon: string;
begin
  Result := FileToString(GEOGET_DATADIR + '\script\GeoTrophy\icon.bmp');
end;

function PluginFlags: string;
begin
  Result := 'nowork';
end;

procedure PluginStart;
var str: string;
begin
  //geo busy
  GeoBusyStart();
  GeoBusyCaption('Generuji odznky z geotrophy.net');
  kind(0); //Stahuji XML
  for i:=-32768 to 32767 do begin end;
  //sthnu
  if HttpAsk('POST', 'http://www.geotrophy.net/geotrophy.xml', '', '', str) then
    //ulom
    StringToFile(str, GEOGET_DATADIR + '\script\GeoTrophy\geotrophy.xml')
  else begin
    //pokud se nepovede soubor sthnout
    ShowMessage('Pi stahovn souboru dolo k chbyb');
    exit;
  end;
  kind(1); //Parsuji XML
  //nulovn zsadnch promnnch
  pocetZemi:=0;
  SetLength(Zeme, 0);
  str:='';
  Xml:=TJclSimpleXML.Create();
  try
    //nahraju si XML
    Xml.loadfromfile(GEOGET_DATADIR + '\script\GeoTrophy\geotrophy.xml', seAuto,0);
    //pro kadou poloku z rootu
    kind(2); //nahrvm data
    for n:=0 to XML.Root.Items.count-1 do
    begin
      //vezmu prvn blok
      ele:=XML.Root.Items[n];
      //jen elementy, ktere me zajimaji
      if ele.name='country' then
      begin
        //vlastnosti - vytvoit
        props:=TJclSimpleXMLProps.create(ele);
        //vlastnosti - nahrt - pro? Mizern dokumentace
        props:=ele.Properties;
        //pole!
        inc(pocetZemi); //zvm poet zem
        SetLength(Zeme, pocetZemi); //nastavm dlku pole
        with Zeme[pocetZemi - 1] do
        begin
          //dlme se seznamem zem
          pocet:=0; //vynuluji poet odznak
          vlastneno:=0;
          SetLength(odznaky, pocet);
          jmeno:=UtfToCharset(Props.Value('name', ''), 'cp1250');
          vitez:=UtfToCharset(Props.Value('winner', ''), 'cp1250');
          for j:=0 to ele.Items.count-1 do begin //pro kad element zem
            if(ele.Items[j].name='cache') then //pokud je to keka
            begin
              subele:=ele.Items[j]; //subelement je keka
              inc(pocet);
              SetLength(odznaky, pocet);
              with odznaky[pocet -1] do //s odznakama
              begin
                for i:=0 to subele.Items.count-1 do
                begin
                  //pokud je nzav dalho subelementu... pak piadm vlastnosti
                  if subele.Items[i].name = 'code' then cache := UtfToCharset(subele.Items[i].Value, 'cp1250');
                  if subele.Items[i].name = 'badge' then obrazek := UtfToCharset(subele.Items[i].Value, 'cp1250');
                  if subele.Items[i].name = 'name' then jmeno := UtfToCharset(subele.Items[i].Value, 'cp1250');
                  if subele.Items[i].name = 'category' then kategorie := UtfToCharset(subele.Items[i].Value, 'cp1250');
                  if subele.Items[i].name = 'desc' then popis := UtfToCharset(subele.Items[i].Value, 'cp1250');
                  mam:=false; //jet odznek nemm
                end; //konec for subelement
              end; //konec with odznaky
            end; //konec if keka
          end; //konec for ele
        end;  //konec with zeme
      end;  //konec if country
    end;  //konec for XML
  finally
  DeleteFile(GEOGET_DATADIR + '\script\GeoTrophy\geotrophy.xml');
  end;
  //popisek
  kind(3); //dotazy do DB
  for i:=0 to pocetZemi-1 do
  begin
    //pro kadou zemi
    with zeme[i] do
    begin
      progress(i, pocetZemi-1, 'Dotazy do DB - ' + jmeno + ' (' + IntToStr(pocet) + 'x)');
      SQL:='SELECT id, dtfound FROM geocache WHERE'; //zatek SQL dotazu
      for j:=0 to pocet-1 do
      begin
        //pro kad potenciln odznek
        with odznaky[j] do
        begin
          //pokud je u odznku popisek, pidm ho do kategorie
          if length(popis) > 0 then kategorie:=kategorie + ' - ' + popis;
          //dopu GC kd do SQL dotazu
          SQL:=SQL + ' id="' + cache + '"';
          if j < pocet-1 then SQL:=SQL + ' OR'; //pidm OR, pokud nen posledn
        end;
      end;
      tabulka:=GeoGet_DB.GetTable(SQL, false);
      while not tabulka.EOF do //pro vechny dky vsledku
      begin
        for j:=0 to pocet-1 do //projdu vechny odznky
        begin
          if tabulka.FieldAsString(0) = odznaky[j].cache then //a pokud se rovn nzev kee v odznku s bodem ve vsledku
          begin
            if tabulka.FieldAsString(1) <> '0' then //a pokud je keka nalezen
            begin
              odznaky[j].mam:=true; //pivlastnm si odznek
              inc(vlastneno); //zvm poet vlastnnch odznk
            end;
          end;
        end;
        tabulka.next();
      end;
    end;
  end;
  kind(4);
  //styl
  _o_:='';
  _o_:=_o_ + '<style>' + CRLF;
  _o_:=_o_ + ' div.gt_pouzdro {text-align: center; position: relative; margin: 0 auto; width: ' + sirka + 'px}' + CRLF;
  _o_:=_o_ + ' div.gt_patro {margin: 0.5em auto;}' + CRLF;
  _o_:=_o_ + ' div.gt_odznak {display: inline-block; margin: 0 auto; zoom:1; *display: inline;}' + CRLF;
  _o_:=_o_ + ' div.gt_winner {display: inline-block; margin: 0 auto; zoom:1; *display: inline; margin: 10px; padding: 10px; border: 1px solid black;}' + CRLF;
  _o_:=_o_ + '</style>' + CRLF + CRLF;

  //generovn HTML
  _o_:=_o_ + '<div class="gt_pouzdro">' + CRLF;
  for i:=0 to pocetZemi-1 do
  begin
    //pro kadou zemi
    if zeme[i].vlastneno > 0 then
    begin
      _o_:=_o_ + '<h3>GeoTrophies: ' + zeme[i].jmeno + '</h3>' + CRLF;
      //nejdve winner odznek
      if zeme[i].pocet = zeme[i].vlastneno then
      begin
        _o_:=_o_ + '<div class="gt_patro">' + CRLF;
        _o_:=_o_ + '<div class="gt_winner">' + CRLF;
        _o_:=_o_ + '<img src="' + zeme[i].vitez + '" alt="I have got all badges from ' + zeme[i].jmeno + '" title="I have got all badges from ' + zeme[i].jmeno + '" />'  + CRLF;
        _o_:=_o_ + '</div>' + CRLF + '</div>' + CRLF;
      end;
      //zatek patra s odznkama
      _o_:=_o_ + '<div class="gt_patro">' + CRLF;
      for j:=0 to zeme[i].pocet-1 do
      begin
        //pro kad odznek v zemi
        if zeme[i].odznaky[j].mam=true then//pokud ho mm
        begin
          _o_:=_o_ + '<div class="gt_odznak">' + CRLF;
          _o_:=_o_ + '<img  src="' + zeme[i].odznaky[j].obrazek + '" alt="' + zeme[i].odznaky[j].kategorie + '"  title="' + zeme[i].odznaky[j].kategorie +'" height="100" width="100" /><br>';
          _o_:=_o_ + '<a href="' + zeme[i].odznaky[j].cache + '" title="' + zeme[i].odznaky[j].jmeno + '">' + zeme[i].odznaky[j].cache + '</a>' +CRLF;
          _o_:=_o_ + '</div>' + CRLF;
        end;
      end;
      _o_:=_o_ + '</div>' + CRLF;
    end;
  end;
  _o_:=_o_ + '</div>';
  _o_:=_o_ + '<div class=gt_pouzdro><a href="http://geotrophy.net">GeoTrophy</a> plugin for <a href="http://geoget.ararat.cz">GeoGet</a>. Plugin version: ' + verze +' by Valicek1</div>';
  StringToFile(_o_, GEOGET_DATADIR + '\script\GeoTrophy\output.html');
  kind(5);
  if zobrazit = 'ano' then RunShell(GEOGET_DATADIR + '\script\GeoTrophy\output.html');
  sleep(500);
end;

procedure PluginWork;
begin
  // Called for each processed point
end;

procedure PluginStop;
begin
  // Called on the end
end;